unit mraveniste;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, DXClass, Menus, IniFiles;

const NUMBER_GRASS=20;
      NUMBER_STONE=20;

type
     TImages = array [0..24,0..19] of byte;
     Grass_Type = record
             x,y : integer;
            end;
     TGrass = array [1..NUMBER_GRASS] of Grass_Type;
     Wood_Type = record
              x,y : integer;
              where : byte;    // kde je vetsivka umistena
             end;

     TWood = array of Wood_Type;
     Stone_Type = record
              x,y : integer;
             end;
     TStone = array [1..NUMBER_STONE] of Stone_Type;

     Egg_Type = record
              x,y : integer;
              where : byte ;   // jestli venku nebo v mravenisti
             end;
     TEgg = array of Egg_Type;      // dynamicke pole.. bude se menit :)


     TAnt_Hill = class
          NUM_MRAVENEC : integer;        // pocet mravencu na zacatku
          NUM_VETVICEK : integer;        // pocet vetvicek na zacatku na plose
          NUM_VET_V_MRAV : integer;       // pocet vetvicek v mravenisti na zacatku
          NUM_EGGS : integer;             // pocet vajicek mimo mraveniste
          ROZ_MRAVENISTE : integer;      // rozmer mraveniste na zacatku
          POSITION_ANT_HILL_X : integer; // x-ova souradnice stredu mrqaveniste na zacatku
          POSITION_ANT_HILL_Y : integer; // y-ova souradnice stredu mrqaveniste na zacatku
          position_well_x : integer;     // x-ova souradnice studny
          position_well_y : integer;     // y-ova souradnice studny
          curr_num_ants : integer;
          curr_num_ants_really : integer;
          curr_num_woods : integer;
          curr_num_woods_really : integer;
          curr_num_carried_woods : integer;
          curr_num_eggs:integer;
          curr_num_woods_hill : integer;
          curr_size_ant_hill : integer;
          curr_pos_ant_hill_x : integer;
          curr_pos_ant_hill_y : integer;
          control : integer;
          counter_hill : integer;
          changed_ant_hill : boolean;
          add_wood_counter : integer;
          add_wood_number : integer;
          add_wood_howmany : integer;
          Data_Images : TImages; // sktruktura, pro vygenerovani obrazku
          Data_Grass : TGrass ;         // pozice travy
          Data_Wood : TWood ;           // pozice vetsvicky
          Data_Wood_Hill : TWood;       // pozice v mravenisti
          Data_Stone : TStone ;         // pozice kamenu
          Data_Egg : TEgg;              // pozice vajicek
          procedure Do_Ant_Hill(rozmer,pocet : integer);
          procedure Generation_Images ;
          procedure LoadBackGround;
          procedure Put_Wood_Into_Hill(whereis, rozmer : integer);
          procedure ReadINI;
          procedure Set_Value;
          procedure WriteINI;
          procedure Add_Wood(count_woods : byte);
          procedure Counter;
          procedure Resize_Ant_Hill;
          procedure Find_Ant(x,y : integer);
          procedure Control_Ant(x,y : integer);
          procedure Monitor_Ant(x,y : integer);
          procedure Add_Eggs(x,y : integer);
     end;


var  Ant_Hill : TAnt_Hill;



implementation

uses mravenec,fanim ;


procedure TAnt_hill.ReadINI;
var IniFile: TIniFile;
    cesta,pom : string;
begin
  cesta:=Application.ExeName;
  pom:=ExtractFilePath(cesta)+'INI_Files\option.ini';
  IniFile:=TIniFile.Create(pom);

  NUM_MRAVENEC:=IniFile.ReadInteger('Options','num_mravenec',30);
  NUM_VETVICEK:=IniFile.ReadInteger('Options','num_vetvicek',70);
  NUM_VET_V_MRAV:=IniFile.ReadInteger('Options','num_vet_v_mrav',50);
  NUM_EGGS := IniFile.ReadInteger('Options','num_eggs',5);
  ROZ_MRAVENISTE:=IniFile.ReadInteger('Options','roz_mraveniste',100);
  POSITION_ANT_HILL_X:=IniFile.ReadInteger('Options','positon_ant_hill_x',400);
  POSITION_ANT_HILL_Y:=IniFile.ReadInteger('Options','positon_ant_hill_y',320);
  IniFile.Free;
end;

procedure TAnt_Hill.WriteINI;
var IniFile : TIniFile;
    cesta,pom : string;
begin
   cesta:=Application.ExeName;
   pom:=ExtractFilePath(cesta)+'INI_Files\option.ini';
   IniFile:=TIniFile.Create(pom);
   IniFile.WriteInteger('Options','num_mravenec',NUM_MRAVENEC);
   IniFile.WriteInteger('Options','num_vetvicek',NUM_VETVICEK);
   IniFile.WriteInteger('Options','num_vet_v_mrav',NUM_VET_V_MRAV);
   IniFile.WriteInteger('Options','num_eggs',NUM_EGGS);
   IniFile.WriteInteger('Options','roz_mraveniste',ROZ_MRAVENISTE);
   IniFile.WriteInteger('Options','positon_ant_hill_x',POSITION_ANT_HILL_X);
   IniFile.WriteInteger('Options','positon_ant_hill_y',POSITION_ANT_HILL_Y);
   IniFile.Free;
end;

procedure TAnt_Hill.Set_Value;
begin
  counter_hill := 0;
  curr_num_ants :=NUM_MRAVENEC;
  curr_num_ants_really := curr_num_ants;
  curr_num_woods := NUM_VETVICEK;
  curr_num_woods_really := NUM_VETVICEK;
  curr_num_woods_hill := NUM_VET_V_MRAV;
  curr_num_eggs := NUM_EGGS;
  curr_num_carried_woods := 0;
  curr_size_ant_hill := ROZ_MRAVENISTE;
  curr_pos_ant_hill_x := POSITION_ANT_HILL_X;
  curr_pos_ant_hill_y := POSITION_ANT_HILL_Y;
  SetLength(Data_Wood,curr_num_woods) ;
  SetLength(Data_Wood_Hill,curr_num_woods_hill) ;
  SetLength(Data_Ants,curr_num_ants);
  SetLength(Data_Egg,curr_num_eggs);
  control:=-1;
  Generation_Images ;
end;


procedure TAnt_Hill.Do_Ant_Hill(rozmer,pocet : integer);
var i,px,py,pom: integer;
begin
  for i:=0 to pocet-1 do begin
    repeat
    px:=random(rozmer);
    py:=random(rozmer);
    pom:=round(sqrt((px-(rozmer div 2))*(px-(rozmer div 2))+(py-(rozmer div 2))*(py-(rozmer div 2))));
     until pom<=(rozmer div 2);
    Data_Wood_Hill[i].x:=px-(rozmer div 2)+ curr_pos_ant_hill_x;
    Data_Wood_Hill[i].y:=py-(rozmer div 2)+ curr_pos_ant_hill_y;
    Data_Wood_Hill[i].where:=1; // vetvicka je v mravenisti
  end;
end;

procedure TAnt_Hill.Resize_Ant_Hill;
 var pom : integer;
begin
if not changed_ant_hill then
begin
  if (curr_num_woods_hill<100) and (curr_size_ant_hill<50) then
      begin
        pom := curr_num_woods_hill mod 5;
        if (pom = 0) then
          begin
            curr_size_ant_hill:=curr_size_ant_hill+5;
            Do_Ant_Hill(curr_size_ant_hill,curr_num_woods_hill);
            changed_ant_hill := true;
          end;
      end;
  if (curr_num_woods_hill>100) and (curr_num_woods_hill<200) and (curr_size_ant_hill<150) then
      begin
        pom := curr_num_woods_hill mod 7;
        if pom = 0 then
          begin
            curr_size_ant_hill:=curr_size_ant_hill+3;
            Do_Ant_Hill(curr_size_ant_hill,curr_num_woods_hill);
            changed_ant_hill := true;
          end;
      end;
  if (curr_num_woods_hill>200) and (curr_num_woods_hill<400) and (curr_size_ant_hill<200) then
      begin
        pom := curr_num_woods_hill mod 10;
        if pom = 0 then
          begin
            curr_size_ant_hill:=curr_size_ant_hill+2;
            Do_Ant_Hill(curr_size_ant_hill,curr_num_woods_hill);
            changed_ant_hill := true;
          end;
      end;
  if (curr_num_woods_hill>400) and (curr_size_ant_hill<400) then
      begin
        pom := (curr_num_woods_hill - 400) mod 20;
        if pom = 0 then
          begin
            curr_size_ant_hill:=curr_size_ant_hill+1;
            Do_Ant_Hill(curr_size_ant_hill,curr_num_woods_hill);
            changed_ant_hill := true;
          end;
      end;
  counter_hill:=0;
 end;
end;

procedure TAnt_Hill.Generation_Images ;  //  procedura pro pocatecni vygenerovani obrazku
var i,j, px,py,pom : integer;
begin
 for i:=0 to 24 do
   for j:=0 to 19 do
     Data_Images[i,j] := 0;
 px := curr_pos_ant_hill_x div 32 ;
 py := curr_pos_ant_hill_y div 32 ;
 for i:=px-3 to px+3 do
   for j:=py-3 to py+3 do
      begin
       Data_Images[i,j] := 1;
      end;
  Do_Ant_Hill(curr_size_ant_hill,curr_num_woods_hill-1);
 for i:=1 to NUMBER_GRASS do
   begin
    repeat
    randomize;
     px := random(23)+1;
     py := random(18)+1;
     pom:=Data_Images[px,py]
    until pom=0  ;
    Data_Images[px,py]:=2;
    Data_Grass[i].x:=px*32;
    Data_Grass[i].y:=py*32;
   end;
 for i:=1 to NUMBER_STONE do
   begin
    repeat
    randomize;
     px := random(23)+1;
     py := random(18)+1;
     pom:=Data_Images[px,py]
    until pom=0  ;
    Data_Images[px,py]:=3;
    Data_Stone[i].x:=px*32;
    Data_Stone[i].y:=py*32;
   end;
   // studna
    repeat
    randomize;
     px := random(15)+5;
     py := random(10)+5;
     pom:=Data_Images[px,py]
    until pom=0  ;
     Data_Images[px,py]:=3;
     position_well_x := px*32;
     position_well_y := py*32;

 for i:=0 to curr_num_woods-1 do
   begin
   repeat
    randomize;
     px := random(750)+20;
     py := random(550)+20;
    until ((px<(curr_pos_ant_hill_x-(curr_size_ant_hill div 2))) or (px>(curr_pos_ant_hill_x+(curr_size_ant_hill div 2)))) and
          ((py<(curr_pos_ant_hill_y-(curr_size_ant_hill div 2))) or (py>(curr_pos_ant_hill_y+(curr_size_ant_hill div 2)))) and
              ((px<position_well_x) or (px>(position_well_x+32))) and
              ((py<position_well_y) or (py>(position_well_y+32))) ;

    Data_Wood[i].x:=px;
    Data_Wood[i].y:=py;
    Data_Wood[i].where:=2; // vetvicka je na plose
   end;

 for i:=0 to curr_num_eggs-1 do
   begin
    repeat
    randomize;
     px := random(23)+1;
     py := random(18)+1;
     pom:=Data_Images[px,py]
    until pom=0  ;
    Data_Images[px,py]:=2;
    Data_Egg[i].x:=px*32;
    Data_Egg[i].y:=py*32;
    Data_Egg[i].where:=2; // vetvicka je na plose
   end;

  add_wood_howmany:=random(5)+1;
  add_wood_number:=random(100)+50;
  add_wood_counter:=0;
end;

procedure TAnt_Hill.Put_Wood_Into_Hill(whereis, rozmer : integer);
var px, py, pom,i: integer;
   free_index : boolean;
begin
 if (whereis>=100) then begin
 whereis:=whereis-100;
 Data_Wood[whereis].where:=3;    // vetvicka je pryc :)
 inc(curr_num_woods_hill); // zvetsime pocet vetsicek v mravenisti
 SetLength(Data_Wood_Hill,curr_num_woods_hill);
 repeat
   px:=random(rozmer);
   py:=random(rozmer);
   pom:=round(sqrt((px-(rozmer div 2))*(px-(rozmer div 2))+(py-(rozmer div 2))*(py-(rozmer div 2))));
 until pom<=(rozmer div 2);
 Data_Wood_Hill[curr_num_woods_hill-1].x:=px-(rozmer div 2)+ curr_pos_ant_hill_x;
 Data_Wood_Hill[curr_num_woods_hill-1].y:=py-(rozmer div 2)+ curr_pos_ant_hill_y;
 Data_Wood_Hill[curr_num_woods_hill-1].where:=1; // vetvicka je v mravenisti
 Resize_Ant_Hill;
 changed_ant_hill := false;     // pribyla vetvicka
 curr_num_carried_woods:=Ant_Hill.curr_num_carried_woods -1; 
  end
  else begin   // vajicko je v mravesnisti.. narodi se novy mravenecek
     whereis:=whereis-10;
     Data_Egg[whereis].where:=3;    // vajicko je pryc :)
     free_index := false;
     i:=0;
     while (i<Ant_Hill.curr_num_ants) and (free_index=false) do begin
        if Data_Ants[i].live=0 then free_index:=true;
        inc(i);
        end;
     if free_index then begin
           Data_Ants[i-1].New_Ant;           // novy mravenec
        end
        else begin  // v poli neni misto .. zvetsime
          curr_num_ants:=curr_num_ants+1;
          SetLength(Data_Ants,curr_num_ants);
          Data_Ants[curr_num_ants-1]:=TMravenec.Init(curr_num_ants-1);
          Data_Ants[curr_num_ants-1].New_Ant;
        end;
 end

 //Do_Ant_Hill(curr_size_ant_hill,curr_num_woods_hill);
end;

procedure TAnt_Hill.Counter;
begin
if add_wood_counter=add_wood_number then
 begin
  Add_Wood(add_wood_howmany);
  randomize;
  add_wood_howmany:=random(10)+1;
  add_wood_number:=random(50);
  add_wood_counter:=-1;
 end;
 inc(add_wood_counter);
end;



procedure TAnt_Hill.Add_Wood(count_woods: byte );
var i, pom,px,py:integer ;
begin
 pom:=0;
 i:=0;
 while ((i<curr_num_woods) and (pom<count_woods))  do
   begin
      if Data_Wood[i].where=3 then
       begin
       repeat
        randomize;
         px := random(750)+20;
         py := random(550)+20;
        until ((px<(curr_pos_ant_hill_x-(curr_size_ant_hill div 2))) or (px>(curr_pos_ant_hill_x+(curr_size_ant_hill div 2)))) and
              ((py<(curr_pos_ant_hill_y-(curr_size_ant_hill div 2))) or (py>(curr_pos_ant_hill_y+(curr_size_ant_hill div 2)))) and
              ((px<position_well_x) or (px>(position_well_x+32))) and
              ((py<position_well_y) or (py>(position_well_y+32))) ;

        Data_Wood[i].x:=px;
        Data_Wood[i].y:=py;
        Data_Wood[i].where:=2; // vetvicka je na plose
        inc(pom);
       end;
    inc(i);
   end;
 curr_num_woods_really := curr_num_woods_really + count_woods ;

end;

procedure TAnt_hill.Add_Eggs(x,y : integer);
var i, pom,px,py:integer ;
    added : boolean;
begin
 i:=0;
 added := false ;
 while ((i<curr_num_eggs) and (added=false)) do
   begin
      if Data_Egg[i].where=3 then
       begin
        Data_Egg[i].x:=x;
        Data_Egg[i].y:=y;
        Data_Egg[i].where:=2; // vetvicka je na plose
        added:=true;
       end;
    inc(i);
   end;
 if added=false then begin     // neni misto pro nove vajicko zvetsime pole
      inc(curr_num_eggs);
      SetLength(Data_Egg,curr_num_eggs);
      Data_Egg[curr_num_eggs-1].x:=x;
      Data_Egg[curr_num_eggs-1].y:=y;
      Data_Egg[curr_num_eggs-1].where:=2; // vetvicka je na plose
    end;
end;

procedure TAnt_Hill.LoadBackGround;
var i:integer;
begin
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,0,0,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,160,0,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,320,0,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,480,0,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,640,0,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,0,160,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,160,160,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,320,160,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,480,160,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,640,160,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,0,320,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,160,320,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,320,320,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,480,320,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,640,320,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,0,480,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,160,480,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,320,480,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,480,480,0);
 MravenisteForm.DXImageList1.Items[0].Draw(MravenisteForm.DXDraw1.Surface,640,480,0);
 for i:=1 to (NUMBER_GRASS div 2) do
   MravenisteForm.DXImageList1.Items[4].Draw(MravenisteForm.DXDraw1.Surface,Data_Grass[i].x,Data_Grass[i].y,0);
 for i:=(NUMBER_GRASS div 2) to NUMBER_GRASS do
   MravenisteForm.DXImageList1.Items[5].Draw(MravenisteForm.DXDraw1.Surface,Data_Grass[i].x,Data_Grass[i].y,0);
 for i:=0 to curr_num_woods_hill-1 do     // vetvicky v mravenisti
     MravenisteForm.DXImageList1.Items[3].Draw(MravenisteForm.DXDraw1.Surface,Data_Wood_Hill[i].x,Data_Wood_Hill[i].y,0);

 for i:=0 to curr_num_woods-1 do
   if Data_Wood[i].where<3 then
     MravenisteForm.DXImageList1.Items[3].Draw(MravenisteForm.DXDraw1.Surface,Data_Wood[i].x,Data_Wood[i].y,0);
 for i:=1 to NUMBER_STONE do
   MravenisteForm.DXImageList1.Items[6].Draw(MravenisteForm.DXDraw1.Surface,Data_Stone[i].x,Data_Stone[i].y,0);
   MravenisteForm.DXImageList1.Items[11].Draw(MravenisteForm.DXDraw1.Surface,position_well_x,position_well_y,0);
 for i:=0 to curr_num_eggs-1 do
   if Data_Egg[i].where=2 then
     MravenisteForm.DXImageList1.Items[10].Draw(MravenisteForm.DXDraw1.Surface,Data_Egg[i].x,Data_Egg[i].y,0);

 end;


procedure TAnt_Hill.Find_Ant(x,y : integer);
var i,px,py:integer;
    found : boolean;
begin
 found:=false;
 i:=0;
 while (i<curr_num_ants) and (found=false) do
   begin
    px:=round(Data_Ants[i].xx);
    py:=round(Data_Ants[i].yy);
    if (x>px-30) and (x<px+30) and (y>py-30) and (y<py+30)then
      begin
       found:=true;
       if Data_Ants[i].move_ant=1 then Data_Ants[i].move_ant:=0
             else Data_Ants[i].move_ant:=1;
      end;
    inc(i);
   end;
end;

procedure TAnt_Hill.Control_Ant(x,y : integer);
var i,px,py:integer;
    found : boolean;
begin
 found:=false;
 i:=0;
 while (i<curr_num_ants) and (found=false) do
   begin
    px:=round(Data_Ants[i].xx);
    py:=round(Data_Ants[i].yy);
    if (x>px-30) and (x<px+30) and (y>py-30) and (y<py+30)then
      begin
       found:=true;
       if (control>=0) then Data_Ants[control].move_ant:=0;
       Data_Ants[i].move_ant:=2;
       control := i;
      end;
    inc(i);
   end;
   if (found=false)  then begin
       if (control>=0) then Data_Ants[control].move_ant:=0;
       control := -1;
     end;
end;

procedure TAnt_Hill.Monitor_Ant(x,y : integer);
var i,px,py:integer;
    found : boolean;
begin
 found:=false;
 i:=0;
 while (i<curr_num_ants) and (found=false) do
   begin
    px:=round(Data_Ants[i].xx);
    py:=round(Data_Ants[i].yy);
    if (x>px-30) and (x<px+30) and (y>py-30) and (y<py+30)then
      begin
       found:=true;
       if (control>=0) then Data_Ants[control].move_ant:=0;
       Data_Ants[i].move_ant:=5;
       control := i;
      end;
    inc(i);
   end;
   if (found=false)  then begin
       if (control>=0) then Data_Ants[control].move_ant:=0;
       control := -1;
     end;
end;



 end.
